Index: /trunk/LMDZ.COMMON/libf/evolution/pem.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 2835)
@@ -754,17 +653,23 @@
      allocate(initial_co2_ice_slope(ngrid,nslope))
      allocate(initial_h2o_ice_slope(ngrid,nslope))
-     year_iter=0
 
 ! We save the places where water ice is sublimating
+! We compute the surface of water ice sublimating
+  ini_surf=0.
+  ini_surf_co2=0.
+  ini_surf_h2o=0.
+  Total_surface=0.
   do i=1,ngrid
-      if (tendencies_h2o_ice_phys(i).LT.0) then
+    Total_surface=Total_surface+cell_area(i)
+    if (tendencies_h2o_ice_phys(i).LT.0) then
          initial_h2o_ice(i)=1.
-      else
+         ini_surf=ini_surf+cell_area(i)
+    else
          initial_h2o_ice(i)=0.         
-      endif
+    endif
     do islope=1,nslope
-
       if (tendencies_co2_ice_phys_slope(i,islope).LT.0) then
          initial_co2_ice_sublim_slope(i,islope)=1.
+         ini_surf_co2=ini_surf_co2+cell_area(i)*subslope_dist(i,islope)
       else
          initial_co2_ice_sublim_slope(i,islope)=0.         
@@ -777,4 +682,5 @@
       if (tendencies_h2o_ice_phys_slope(i,islope).LT.0) then
          initial_h2o_ice_slope(i,islope)=1.
+         ini_surf_h2o=ini_surf_h2o+cell_area(i)*subslope_dist(i,islope)
       else
          initial_h2o_ice_slope(i,islope)=0.         
@@ -783,35 +689,16 @@
   enddo
 
-! We compute the surface of water ice sublimating
-  ini_surf=0.
-  ini_surf_co2=0.
-  ini_surf_h2o=0.
-  Total_surface=0.
-  do i=1,ngrid
-    if (initial_h2o_ice(i).GT.0.5) then
-       ini_surf=ini_surf+cell_area(i)
-    endif
-    do islope=1,nslope
-      if (initial_co2_ice_sublim_slope(i,islope).GT.0.5) then
-         ini_surf_co2=ini_surf_co2+cell_area(i)*subslope_dist(i,islope)
-      endif
-      if (initial_h2o_ice_slope(i,islope).GT.0.5) then
-         ini_surf_h2o=ini_surf_h2o+cell_area(i)*subslope_dist(i,islope)
-      endif
-    enddo
-    Total_surface=Total_surface+cell_area(i)
-  enddo
-
-     print *, "ini_surf_co2=", ini_surf_co2
-     print *, "ini_surf=", ini_surf
-     print *, "ini_surf_h2o=", ini_surf_h2o
-
-
-     allocate(local_old_press(ngrid))
-     allocate(local_new_press(ngrid))
+     print *, "Total initial surface of co2ice sublimating (slope)=", ini_surf_co2
+     print *, "Total initial surface of h2o ice sublimating=", ini_surf
+     print *, "Total initial surface of h2o ice sublimating (slope)=", ini_surf_h2o
+     print *, "Total surface of the planet=", Total_surface
     
-     allocate(zplev_new(ngrid,nlayer+1))
-     allocate(zplev_old(ngrid,nlayer+1))
-
+     allocate(zplev_gcm(ngrid,nlayer+1))
+
+     DO l=1,nlayer+1
+       DO ig=1,ngrid
+         zplev_gcm(ig,l) = ap(l)  + bp(l)*ps_phys(ig)
+       ENDDO
+     ENDDO
 
      global_ave_press_old=0.
@@ -821,66 +708,69 @@
 
      global_ave_press_GCM=global_ave_press_old
-     print *, "global_ave_press_old", global_ave_press_old
-     
-
-
-!----- Time loop
-     print *, "Before timeloop"
-     allocate(flag_co2flow(ngrid,nslope))
-     allocate(flag_co2flow_mesh(ngrid))
-
-     firstcall=.TRUE.
-
-
-
-
+     global_ave_press_new=global_ave_press_old
+     print *, "Initial global average pressure=", global_ave_press_GCM
 
 !------------------------
 
 ! I   Initialisation
-!    I_a READ run.def , run_pem.def
-!    I_b READ starfi_0.nc
-!    I_c READ GCM data and convert to the physical grid 
-!    I_d Compute tendencies & Save initial situation
-!    I_e Read startfi_PEM
-
-!------------------------
-
-
-! now we complete with the PEMstart
+!    I_a READ run.def 
+!    I_b READ of start_evol.nc and starfi_evol.nc
+!    I_c Subslope parametrisation
+!    I_d READ GCM data and convert to the physical grid 
+!    I_e Initialisation of the PEM variable and soil 
+!    I_f Compute tendencies & Save initial situation
+!    I_g Save initial PCM situation
+!    I_h Read the PEMstart
+
+!---------------------------- Read the PEMstart --------------------- 
 
       call pemetat0(.false.,"startfi_PEM.nc",ngrid,nsoilmx,nsoilmx_PEM,nslope,timelen,timestep,TI_PEM,tsoil_ave_phys_yr1,tsoil_PEM,ice_depth, &
-      tsurf_ave_phys_yr1, tsurf_ave_phys, q_co2_PEM_phys, q_h2o_PEM_phys,ps_phys_timeseries_yr1,ps_phys_timeseries,tsurf_phys_GCM_timeseries,tsoil_phys_PEM_timeseries,&
+      tsurf_ave_phys_yr1, tsurf_ave_phys, q_co2_PEM_phys, q_h2o_PEM_phys,ps_phys_timeseries,tsurf_phys_GCM_timeseries,tsoil_phys_PEM_timeseries,&
       tendencies_h2o_ice_phys_slope,tendencies_co2_ice_phys_slope,co2ice_slope,qsurf_slope(:,igcm_h2o_ice,:), co2_adsorbded_phys,delta_co2_adsorbded)
-totmass_adsorbded = 0.
+
+
+    if(soil_pem) then
+     totmass_adsorbded = 0.
+
      do ig = 1,ngrid
       do islope =1, nslope
        do l = 1,nsoilmx_PEM - 1
-
           totmass_adsorbded = totmass_adsorbded + co2_adsorbded_phys(ig,l,islope)*(layer_PEM(l+1) - layer_PEM(l))* &
           subslope_dist(ig,islope)/cos(pi*def_slope_mean(islope)/180.) * &
           cell_area(ig)
        enddo
-
       enddo
-
      enddo
 
-     write(*,*) "tot mass in the regolith", totmass_adsorbded
-     stop
+     write(*,*) "Tot mass in the regolith=", totmass_adsorbded
+     deallocate(tsoil_ave_phys_yr1)  
+    endif !soil_pem
      deallocate(tsurf_ave_phys_yr1)
-     deallocate(ps_phys_timeseries_yr1)
-     deallocate(tsoil_ave_phys_yr1)    
-
+     deallocate(ps_phys_timeseries_yr1)  
+
+!------------------------
+
+! I   Initialisation
+!    I_a READ run.def 
+!    I_b READ of start_evol.nc and starfi_evol.nc
+!    I_c Subslope parametrisation
+!    I_d READ GCM data and convert to the physical grid 
+!    I_e Initialisation of the PEM variable and soil 
+!    I_f Compute tendencies & Save initial situation
+!    I_g Save initial PCM situation
+!    I_h Read the PEMstar
+!    I_i Compute orbit criterion
+
+     CALL iniorbit(aphelie,periheli,year_day,peri_day,obliquit)
+
+     if(evol_orbit_pem) then
+       call orbit_param_criterion(year_iter_max)
+     else
+       year_iter_max=Max_iter_pem
+     endif
 
 !--------------------------- END INITIALISATION ---------------------
 
-
-
-
 !---------------------------- RUN ---------------------
-
-
-
 
 !------------------------
@@ -890,92 +780,49 @@
 
 !------------------------
-
-    
-     do while (.true.)
-! II.a.1. global pressure
-     global_ave_press_new=global_ave_press_old
-
+     year_iter=0
+     print *, "Max_iter_pem", Max_iter_pem
+     do while (year_iter.LT.year_iter_max)
+
+! II.a.1. Compute updated global pressure
+     print *, "Recomputing the new pressure..."
      do i=1,ngrid
        do islope=1,nslope
            global_ave_press_new=global_ave_press_new-g*cell_area(i)*tendencies_co2_ice_phys_slope(i,islope)*subslope_dist(i,islope)/cos(pi*def_slope_mean(islope)/180.)/Total_surface
        enddo
-     
-      global_ave_press_new = global_ave_press_new -g*cell_area(i)*delta_co2_adsorbded(i)/Total_surface
+       if(soil_pem) then
+         global_ave_press_new = global_ave_press_new -g*cell_area(i)*delta_co2_adsorbded(i)/Total_surface
+       endif
      enddo
-! II.a.2. tracers
+
+! II.a.2. Old pressure levels for the timeseries, this value is deleted when unused and recreated each time (big memory consuption)
      allocate(zplev_old_timeseries(ngrid,nlayer+1,timelen))
-        DO l=1,nlayer+1
-         DO ig=1,ngrid
-          zplev_old(ig,l) = ap(l)  + bp(l)*ps_phys(ig)
-          zplev_old_timeseries(ig,l,:) = ap(l)  + bp(l)*ps_phys_timeseries(ig,:)
-         ENDDO
-        ENDDO
-
-     do i=1,ip1jmp1
-
-       ps(i)=ps(i)*global_ave_press_new/global_ave_press_old
-
-     enddo
+     print *, "Recomputing the old pressure levels timeserie adapted to the old pressure..."
+     DO l=1,nlayer+1
+       DO ig=1,ngrid
+         zplev_old_timeseries(ig,l,:) = ap(l)  + bp(l)*ps_phys_timeseries(ig,:)
+       ENDDO
+     ENDDO
+
+! II.a.3. Surface pressure timeseries
+     print *, "Recomputing the surface pressure timeserie adapted to the new pressure..."
      do i = 1,ngrid
-       ps_phys(i)=ps_phys(i)*global_ave_press_new/global_ave_press_old
        ps_phys_timeseries(i,:) = ps_phys_timeseries(i,:)*global_ave_press_new/global_ave_press_old
      enddo
 
+! II.a.4. New pressure levels timeseries
      allocate(zplev_new_timeseries(ngrid,nlayer+1,timelen))
-
-        do l=1,nlayer+1
-         do ig=1,ngrid
-          zplev_new(ig,l) = ap(l)  + bp(l)*ps_phys(ig)
-          zplev_new_timeseries(ig,l,:)  = ap(l)  + bp(l)*ps_phys_timeseries(ig,:)
-         enddo
-        enddo
-
-
-      print *, "1 is okay"
-
-        DO nnq=1,nqtot
-        if (noms(nnq).NE."co2") then
-          DO l=1,llm-1
-            DO ig=1,ngrid
-               q(ig,l,nnq)=q(ig,l,nnq)*(zplev_old(ig,l)-zplev_old(ig,l+1))/(zplev_new(ig,l)-zplev_new(ig,l+1))
-            ENDDO
-            q(:,llm,nnq)=q(:,llm-1,nnq)
-          ENDDO
-        else
-          DO l=1,llm-1
-            DO ig=1,ngrid
-                q(ig,l,nnq)=q(ig,l,nnq)*(zplev_old(ig,l)-zplev_old(ig,l+1))/(zplev_new(ig,l)-zplev_new(ig,l+1))  &
-                                + (   (zplev_new(ig,l)-zplev_new(ig,l+1))  -       &
-                                      (zplev_old(ig,l)-zplev_old(ig,l+1))     )  / &
-                                      (zplev_new(ig,l)-zplev_new(ig,l+1))
-            ENDDO
-           q(:,llm,nnq)=q(:,llm-1,nnq)
-          ENDDO
-        endif
-        ENDDO
-
-
- DO nnq=1,nqtot
-       DO ig=1,ngrid
-         DO l=1,llm-1
-          if(q(ig,l,nnq).GT.1 .and. (noms(nnq).NE."dust_number" .or. noms(nnq).NE."ccn_number") ) then
-              extra_mass=(q(ig,l,nnq)-1)*(zplev_new(ig,l)-zplev_new(ig,l+1))
-              q(ig,l,nnq)=1.
-              q(ig,l+1,nnq)=q(ig,l+1,nnq)+extra_mass*(zplev_new(ig,l+1)-zplev_new(ig,l+2))
-          endif
-          if(q(ig,l,nnq).LT.0) then
-              q(ig,l,nnq)=1E-30
-          endif
-         ENDDO
+     print *, "Recomputing the new pressure levels timeserie adapted to the new pressure..."
+     do l=1,nlayer+1
+       do ig=1,ngrid
+         zplev_new_timeseries(ig,l,:)  = ap(l)  + bp(l)*ps_phys_timeseries(ig,:)
        enddo
-   enddo
-
-
-
-
-  l=1
-  DO ig=1,ngrid
-      DO t = 1, timelen
-
+     enddo
+
+! II.a.5. Tracers timeseries
+      print *, "Recomputing of tracer VMR timeseries for the new pressure..."
+
+     l=1
+     DO ig=1,ngrid
+       DO t = 1, timelen
          q_h2o_PEM_phys(ig,t)=q_h2o_PEM_phys(ig,t)*(zplev_old_timeseries(ig,l,t)-zplev_old_timeseries(ig,l+1,t))/(zplev_new_timeseries(ig,l,t)-zplev_new_timeseries(ig,l+1,t))
          if(q_h2o_PEM_phys(ig,t).LT.0) then
@@ -985,12 +832,9 @@
            q_h2o_PEM_phys(ig,t)=1.
          endif
-
-   enddo
-  enddo
-
-
-
-  DO ig=1,ngrid
-      DO t = 1, timelen
+       enddo
+     enddo
+
+     DO ig=1,ngrid
+       DO t = 1, timelen
          q_co2_PEM_phys(ig,t)=q_co2_PEM_phys(ig,t)*(zplev_old_timeseries(ig,l,t)-zplev_old_timeseries(ig,l+1,t))/(zplev_new_timeseries(ig,l,t)-zplev_new_timeseries(ig,l+1,t))  &
                                 + (   (zplev_new_timeseries(ig,l,t)-zplev_new_timeseries(ig,l+1,t))  -       &
@@ -1004,32 +848,31 @@
          mmean=1/(A*q_co2_PEM_phys(ig,t) +B)
          vmr_co2_pem_phys(ig,t) = q_co2_PEM_phys(ig,t)*mmean/m_co2
-      ENDDO
-  ENDDO
+       ENDDO
+     ENDDO
    
      deallocate(zplev_new_timeseries)
      deallocate(zplev_old_timeseries)
 
-
-! II.a.3. Evolution of the ice
-
-
-     call evol_h2o_ice_s_slope(qsurf_slope(:,igcm_h2o_ice,:),tendencies_h2o_ice_phys_slope,iim,jjm,ngrid,cell_area,STOPPING_1_water,nslope)
-      print *, "4 is okay"
-
-     call evol_co2_ice_s_slope(co2ice_slope,tendencies_co2_ice_phys_slope,iim,jjm,ngrid,cell_area,STOPPING_1_co2,nslope)
-      print *, "5 is okay"
-
-
-!------------------------
-
 ! II  Run
 !    II_a update pressure, ice and tracers 
-!    II_b CO2 glaciers flows 
-
-!------------------------
-
-    
-
-
+!    II_b Evolution of the ice
+
+! II.b. Evolution of the ice
+      print *, "Evolution of h2o ice"
+     call evol_h2o_ice_s_slope(qsurf_slope(:,igcm_h2o_ice,:),tendencies_h2o_ice_phys_slope,iim,jjm,ngrid,cell_area,STOPPING_1_water,nslope)
+
+      print *, "Evolution of co2 ice"
+     call evol_co2_ice_s_slope(co2ice_slope,tendencies_co2_ice_phys_slope,iim,jjm,ngrid,cell_area,STOPPING_1_co2,nslope)
+
+!------------------------
+
+! II  Run
+!    II_a update pressure, ice and tracers 
+!    II_b Evolution of the ice
+!    II_c CO2 glaciers flows 
+
+!------------------------
+
+      print *, "Co2 glacier flow"
        DO ig = 1,ngrid
         DO islope = 1,nslope
@@ -1038,7 +881,5 @@
             IF(co2ice_slope(ig,islope).ge.rho_co2*co2_hmax(islope) * &
                   cos(pi*def_slope_mean(islope)/180.)) THEN 
-
 ! Second: determine the flatest slopes possible:
-       
                 IF(islope.gt.iflat) THEN
                   iaval=islope-1
@@ -1048,5 +889,4 @@
                 do while ((iaval.ne.iflat).and.  &
                     (subslope_dist(ig,iaval).eq.0))
-
                   IF(iaval.gt.iflat) THEN
                      iaval=iaval-1
@@ -1054,9 +894,6 @@
                      iaval=iaval+1
                   ENDIF
-             
                 enddo
-
-
-                co2ice_slope(ig,iaval) = co2ice_slope(ig,iaval) + &
+              co2ice_slope(ig,iaval) = co2ice_slope(ig,iaval) + &
                (co2ice_slope(ig,islope) - rho_co2* co2_hmax(islope) *     &
                cos(pi*def_slope_mean(islope)/180.)) *             &
@@ -1065,9 +902,9 @@
                cos(pi*def_slope_mean(islope)/180.)                
 
-                co2ice_slope(ig,islope)=rho_co2*co2_hmax(islope) *        &
-                  cos(pi*def_slope_mean(islope)/180.) 
-
-             flag_co2flow(ig,islope) = 1.
-             flag_co2flow_mesh(ig) = 1.
+              co2ice_slope(ig,islope)=rho_co2*co2_hmax(islope) *        &
+               cos(pi*def_slope_mean(islope)/180.) 
+
+              flag_co2flow(ig,islope) = 1.
+              flag_co2flow_mesh(ig) = 1.
             ENDIF ! co2ice > hmax
           ENDIF ! iflattsoil_lope
@@ -1075,107 +912,93 @@
        ENDDO !ig
 
-      print *, "6 is okay"
-
 !------------------------
 
 ! II  Run
 !    II_a update pressure, ice and tracers 
-!    II_b CO2 glaciers flows 
-!    II_c Update surface and soil temperatures
-
-!------------------------
-
-
-! II_c.1 Update Tsurf
+!    II_b Evolution of the ice
+!    II_c CO2 glaciers flows 
+!    II_d Update surface and soil temperatures
+
+!------------------------
+
+! II_d.1 Update Tsurf
+
+      print *, "Updating the new Tsurf"
       bool_sublim=0
       Tsurfave_before_saved(:,:) = tsurf_ave_phys(:,:)
-       DO ig = 1,ngrid
+      DO ig = 1,ngrid
         DO islope = 1,nslope
-           if(initial_co2_ice_slope(ig,islope).gt.0.5 .and. co2ice_slope(ig,islope).LT. 1E-5) THEN !co2ice disappeared, look for closest point without co2ice
-
-
-              if(latitude_deg(ig).gt.0) then
-                do ig_loop=ig,ngrid
-                  DO islope_loop=islope,iflat,-1
-                     if(initial_co2_ice_slope(ig_loop,islope_loop).lt.0.5 .and. co2ice_slope(ig_loop,islope_loop).LT. 1E-5) then
-                            tsurf_ave_phys(ig,islope)=tsurf_ave_phys(ig_loop,islope_loop)
-                            bool_sublim=1
-                            exit
-                     endif
-                  enddo
-                  if (bool_sublim.eq.1) then
-                   exit
+          if(initial_co2_ice_slope(ig,islope).gt.0.5 .and. co2ice_slope(ig,islope).LT. 1E-5) THEN !co2ice disappeared, look for closest point without co2ice
+            if(latitude_deg(ig).gt.0) then
+              do ig_loop=ig,ngrid
+                DO islope_loop=islope,iflat,-1
+                  if(initial_co2_ice_slope(ig_loop,islope_loop).lt.0.5 .and. co2ice_slope(ig_loop,islope_loop).LT. 1E-5) then
+                    tsurf_ave_phys(ig,islope)=tsurf_ave_phys(ig_loop,islope_loop)
+                    bool_sublim=1
+                    exit
                   endif
                 enddo
-              else
-               do ig_loop=ig,1,-1
-                  DO islope_loop=islope,iflat
-                     if(initial_co2_ice_slope(ig_loop,islope_loop).lt.0.5 .and. co2ice_slope(ig_loop,islope_loop).LT. 1E-5) then
-                            tsurf_ave_phys(ig,islope)=tsurf_ave_phys(ig_loop,islope_loop)
-                            bool_sublim=1
-                            exit
-                     endif
-                  enddo
-                  if (bool_sublim.eq.1) then
-                   exit
+                if (bool_sublim.eq.1) then
+                  exit
+                endif
+              enddo
+            else
+              do ig_loop=ig,1,-1
+                DO islope_loop=islope,iflat
+                  if(initial_co2_ice_slope(ig_loop,islope_loop).lt.0.5 .and. co2ice_slope(ig_loop,islope_loop).LT. 1E-5) then
+                    tsurf_ave_phys(ig,islope)=tsurf_ave_phys(ig_loop,islope_loop)
+                    bool_sublim=1
+                    exit
                   endif
                 enddo
-
+                if (bool_sublim.eq.1) then
+                  exit
+                endif
+              enddo
+            endif
+            initial_co2_ice_slope(ig,islope)=0
+            if ((co2ice_slope(ig,islope).lt.1e-5).and. (qsurf_slope(ig,igcm_h2o_ice,islope).gt.frost_albedo_threshold))  then   
+              albedo_slope(ig,1,islope) = albedo_h2o_frost
+              albedo_slope(ig,2,islope) = albedo_h2o_frost
+            else
+              albedo_slope(ig,1,islope) = albedodat(ig)
+              albedo_slope(ig,2,islope) = albedodat(ig) 
+              emiss_slope(ig,islope) = emissiv         
+            endif
+          elseif( co2ice_slope(ig,islope).GT. 1E-5) THEN !Put tsurf as tcond co2
+            ave=0.
+            do t=1,timelen
+              if(co2_ice_GCM_phys_slope(ig,islope,t).gt.1e-5) then
+                ave = ave + beta/(alpha-log(vmr_co2_pem_phys(ig,t)*ps_phys_timeseries(ig,t)/100.))
+              else
+                ave = ave + tsurf_phys_GCM_timeseries(ig,islope,t)
               endif
-              initial_co2_ice_slope(ig,islope)=0
-
-              if ((co2ice_slope(ig,islope).lt.1e-5).and. (qsurf_slope(ig,igcm_h2o_ice,islope).gt.frost_albedo_threshold))  then
-                 
-               albedo_slope(ig,1,islope) = albedo_h2o_frost
-               albedo_slope(ig,2,islope) = albedo_h2o_frost
-
-              else
-                            
-               albedo_slope(ig,1,islope) = albedodat(ig)
-               albedo_slope(ig,2,islope) = albedodat(ig) 
-               emiss_slope(ig,islope) = emissiv         
-
-              endif
-
-           elseif( co2ice_slope(ig,islope).GT. 1E-5) THEN !Put tsurf as tcond co2
-  
-             ave=0.
-             do t=1,timelen
-              if(co2_ice_GCM_phys_slope(ig,islope,t).gt.1e-5) then
-                 ave = ave + beta/(alpha-log(vmr_co2_pem_phys(ig,t)*ps_phys_timeseries(ig,t)/100.))
-              else
-                 ave = ave + tsurf_phys_GCM_timeseries(ig,islope,t)
-              endif
-             enddo
-
-             tsurf_ave_phys(ig,islope)=ave/timelen
-           endif
+            enddo
+            tsurf_ave_phys(ig,islope)=ave/timelen
+          endif
         enddo
-       enddo
-
-      print *, "7 is okay"
-   
-     do t = 1,timelen
-     tsurf_phys_GCM_timeseries(:,:,t) = tsurf_phys_GCM_timeseries(:,:,t) +( tsurf_ave_phys(:,:) -Tsurfave_before_saved(:,:)) 
-     enddo
-! for the start
-     do ig = 1,ngrid
-      do islope = 1,nslope
-     tsurf_slope(ig,islope) =  tsurf_slope(ig,islope) - (Tsurfave_before_saved(ig,islope)-tsurf_ave_phys(ig,islope))
-     enddo
-     enddo
-
-! II_c.2 Update soil temperature
-
-allocate(TI_locslope(ngrid,nsoilmx_PEM))
-allocate(Tsoil_locslope(ngrid,nsoilmx_PEM))
-allocate(Tsurf_locslope(ngrid))
-allocate(alph_locslope(ngrid,nsoilmx_PEM-1))
-allocate(beta_locslope(ngrid,nsoilmx_PEM-1))
-
-
-
-
-print *,"8 is ok"
+      enddo
+
+      do t = 1,timelen
+        tsurf_phys_GCM_timeseries(:,:,t) = tsurf_phys_GCM_timeseries(:,:,t) +( tsurf_ave_phys(:,:) -Tsurfave_before_saved(:,:)) 
+      enddo
+      ! for the start
+      do ig = 1,ngrid
+        do islope = 1,nslope
+          tsurf_slope(ig,islope) =  tsurf_slope(ig,islope) - (Tsurfave_before_saved(ig,islope)-tsurf_ave_phys(ig,islope))
+        enddo
+      enddo
+
+    if(soil_pem) then
+
+! II_d.2 Update soil temperature
+
+  allocate(TI_locslope(ngrid,nsoilmx_PEM))
+  allocate(Tsoil_locslope(ngrid,nsoilmx_PEM))
+  allocate(Tsurf_locslope(ngrid))
+  allocate(alph_locslope(ngrid,nsoilmx_PEM-1))
+  allocate(beta_locslope(ngrid,nsoilmx_PEM-1))
+
+  print *,"Updating soil temperature"
 
 ! Soil averaged
@@ -1186,6 +1009,6 @@
      alph_locslope(:,:) = alph_PEM(:,:,islope)
      beta_locslope(:,:) = beta_PEM(:,:,islope)
-     call soil_pem(ngrid,nsoilmx_PEM,.true.,TI_locslope,timestep,Tsurf_locslope,Tsoil_locslope,alph_locslope,beta_locslope)
-     call soil_pem(ngrid,nsoilmx_PEM,.false.,TI_locslope,timestep,Tsurf_locslope,Tsoil_locslope,alph_locslope,beta_locslope)
+     call soil_pem_routine(ngrid,nsoilmx_PEM,.true.,TI_locslope,timestep,Tsurf_locslope,Tsoil_locslope,alph_locslope,beta_locslope)
+     call soil_pem_routine(ngrid,nsoilmx_PEM,.false.,TI_locslope,timestep,Tsurf_locslope,Tsoil_locslope,alph_locslope,beta_locslope)
      do t = 1,timelen
        tsoil_phys_PEM_timeseries(:,:,islope,t) =  tsoil_phys_PEM_timeseries(:,:,islope,t) + (Tsoil_locslope(:,:)- tsoil_PEM(:,:,islope))
@@ -1198,41 +1021,34 @@
   enddo
 
-
-      print *, "9 is okay"
-
-
-!!!!!! Check for the time series
-
-   
-      do ig = 1,ngrid
+  print *, "Update of soil temperature done"
+
+! Check Nan in the time series
+     do ig = 1,ngrid
        do islope = 1,nslope
          do iloop = 1,nsoilmx_PEM
- 
-         if(isnan(tsoil_PEM(ig,iloop,islope))) then
-          write(*,*) "is nan tsoil", ig, iloop, islope, tsoil_PEM(ig,iloop,islope)
+           if(isnan(tsoil_PEM(ig,iloop,islope))) then
+            write(*,*) "Problem : There is nan tsoil", ig, iloop, islope, tsoil_PEM(ig,iloop,islope)
            stop 
-         endif
+           endif
          enddo
-        enddo
-      enddo
-
-
-write(*,*) "before ice table, no stop"
-
-! II_c.3 Update the ice table
+       enddo
+     enddo
+
+  write(*,*) "Compute ice table"
+
+! II_d.3 Update the ice table
      call computeice_table(timelen,ngrid,nslope,nsoilmx,nsoilmx_PEM, tsoil_phys_PEM_timeseries,tsurf_phys_GCM_timeseries,q_co2_PEM_phys,q_h2o_PEM_phys, & 
                            ps_phys_timeseries, ice_depth)
        
-      print *, "10 is okay"
-! II_c.3 Update the soil thermal properties
-      call update_soil(ngrid,nslope,nsoilmx_PEM,tendencies_h2o_ice_phys_slope,tendencies_co2_ice_phys_slope,co2ice_slope,qsurf_slope(:,igcm_h2o_ice,:),ps_phys, &
-        cell_area,ice_depth,TI_PEM)
-
-! II_c.4 Update the mass of the regolith adsorbded
-   
-  
+      print *, "Update soil propreties"
+! II_d.4 Update the soil thermal properties
+      call update_soil(ngrid,nslope,nsoilmx_PEM,tendencies_h2o_ice_phys_slope,tendencies_co2_ice_phys_slope,co2ice_slope,qsurf_slope(:,igcm_h2o_ice,:),global_ave_press_new, &
+        ice_depth,TI_PEM)
+
+! II_d.5 Update the mass of the regolith adsorbded
    call regolith_co2adsorption(ngrid,nslope,nsoilmx_PEM,timelen,ps_phys_timeseries,tsoil_PEM,TI_PEM,tendencies_h2o_ice_phys_slope,tendencies_co2_ice_phys_slope, & 
                                co2ice_slope,qsurf_slope(:,igcm_h2o_ice,:), q_co2_PEM_phys,q_h2o_PEM_phys,co2_adsorbded_phys,delta_co2_adsorbded)
 
+  endif !soil_pem
 
 !------------------------
@@ -1240,113 +1056,120 @@
 ! II  Run
 !    II_a update pressure, ice and tracers 
-!    II_b CO2 glaciers flows 
-!    II_c Update surface and soil temperatures
-!    II_d Update the tendencies and stopping criterion
-
-!------------------------
-
-
+!    II_b Evolution of the ice
+!    II_c CO2 glaciers flows 
+!    II_d Update surface and soil temperatures
+!    II_e Update the tendencies 
+
+!------------------------
+
+      print *, "Adaptation of the new co2 tendencies to the current pressure"
       call recomp_tend_co2_slope(tendencies_co2_ice_phys_slope,tendencies_co2_ice_phys_slope_ini,vmr_co2_gcm_phys,vmr_co2_pem_phys,ps_phys_timeseries,&     
                                global_ave_press_GCM,global_ave_press_new,timelen,ngrid,nslope)
 
-          print *, "12 is okay"
+!------------------------
+
+! II  Run
+!    II_a update pressure, ice and tracers 
+!    II_b Evolution of the ice
+!    II_c CO2 glaciers flows 
+!    II_d Update surface and soil temperatures
+!    II_e Update the tendencies 
+!    II_f Checking the stopping criterion
+
+!------------------------
+      call criterion_ice_stop_water_slope(cell_area,ini_surf_h2o,qsurf_slope(:,igcm_h2o_ice,:),STOPPING_water,ngrid,initial_h2o_ice_slope)
+
+      call criterion_ice_stop_slope(cell_area,ini_surf_co2,co2ice_slope,STOPPING_co2,ngrid,initial_co2_ice_sublim_slope,global_ave_press_GCM,global_ave_press_new,nslope)
+
       year_iter=year_iter+dt_pem
 
-!We check with we should stop
-
-
-      call criterion_ice_stop_water_slope(cell_area,ini_surf_h2o,qsurf_slope(:,igcm_h2o_ice,:),STOPPING_water,ngrid,initial_h2o_ice_slope)
-
-
-          print *, "13 is okay"
-      call criterion_ice_stop_slope(cell_area,ini_surf_co2,co2ice_slope,STOPPING_co2,ngrid,initial_co2_ice_sublim_slope,global_ave_press_GCM,global_ave_press_new,nslope)
-
- print *, "criterion ok"
-
-
-      print *, "STOPPING_water", STOPPING_water, "STOPPING1_water", STOPPING_1_water
-      print *, "STOPPING_co2", STOPPING_co2, "STOPPING1_co2", STOPPING_1_co2
-      print *, "year_iter=", year_iter
+      print *, "Checking all the stopping criterion."
+      if (STOPPING_water) then
+        print *, "STOPPING because surface of water ice sublimating is too low, see message above", STOPPING_water 
+      endif
+      if (STOPPING_1_water) then
+        print *, "STOPPING because tendencies on water ice=0, see message above", STOPPING_1_water
+      endif
+      if (STOPPING_co2) then
+        print *, "STOPPING because surface of co2 ice sublimating is too low or global pressure changed too much, see message above", STOPPING_co2
+      endif
+      if (STOPPING_1_co2) then
+        print *, "STOPPING because tendencies on co2 ice=0, see message above", STOPPING_1_co2
+      endif
+
       if (STOPPING_water .or. STOPPING_1_water .or. STOPPING_co2 .or. STOPPING_1_co2)  then
         exit
+      else
+        print *, "We continue!"
+        print *, "Number of iteration of the PEM : year_iter=", year_iter  
       endif
 
       global_ave_press_old=global_ave_press_new
-      zplev_old=zplev_new
-
-
-      enddo  ! big loop of the pem
+
+      enddo  ! big time iteration loop of the pem
 
 
 !---------------------------- END RUN PEM ---------------------
 
-
-
-
 !---------------------------- OUTPUT ---------------------
 
-
-
-
 !------------------------
 
 ! III Output
-!    III_a Recomp tendencies for the start and startfi
-
-!------------------------
-
-
-! III_a.1 Ice update
+!    III_a Update surface value for the PCM start files
+
+!------------------------
+
+! III_a.1 Ice update (for startfi)
+! Co2 ice
       DO ig = 1,ngrid
-          co2ice(ig) = 0.
-             DO islope = 1,nslope
-                 co2ice(ig) = co2ice(ig) + co2ice_slope(ig,islope) &
-                            * subslope_dist(ig,islope) /          &
-                           cos(pi*def_slope_mean(islope)/180.)
-             ENDDO
+        co2ice(ig) = 0.
+        DO islope = 1,nslope
+          co2ice(ig) = co2ice(ig) + co2ice_slope(ig,islope) &
+                      * subslope_dist(ig,islope) /          &
+                      cos(pi*def_slope_mean(islope)/180.)
+        ENDDO
       ENDDO ! of DO ig=1,ngrid
-
-      DO ig = 1,ngrid !!!!! TO DOC GHANGE IF QSURF ?ü!?!?!?
-          qsurf(ig,igcm_h2o_ice) = 0.
-             DO islope = 1,nslope
-                 qsurf(ig,igcm_h2o_ice) = qsurf(ig,igcm_h2o_ice) + qsurf_slope(ig,igcm_h2o_ice,islope) &
-                            * subslope_dist(ig,islope) /          &
-                           cos(pi*def_slope_mean(islope)/180.)
-             ENDDO
+! H2o ice
+      DO ig = 1,ngrid
+        qsurf(ig,igcm_h2o_ice) = 0.
+        DO islope = 1,nslope
+          qsurf(ig,igcm_h2o_ice) = qsurf(ig,igcm_h2o_ice) + qsurf_slope(ig,igcm_h2o_ice,islope) &
+                                   * subslope_dist(ig,islope) /          &
+                                  cos(pi*def_slope_mean(islope)/180.)
+        ENDDO
       ENDDO ! of DO ig=1,ngrid
 
-
-
-
-! III_a.2 Tsurf and Tsoil update
-
-
-   call interpolate_TIPEM_TIGCM(ngrid,nslope,nsoilmx_PEM,nsoilmx,TI_PEM,TI_GCM_phys)
-   tsoil_slope(:,:,:) = tsoil_phys_PEM_timeseries(:,:,:,timelen)
-
+! III_a.2 Tsurf and Tsoil update (for startfi)
+
+   if(soil_pem) then
+     call interpolate_TIPEM_TIGCM(ngrid,nslope,nsoilmx_PEM,nsoilmx,TI_PEM,TI_GCM_phys)
+     tsoil_slope(:,:,:) = tsoil_phys_PEM_timeseries(:,:,:,timelen)
+   else
+      TI_GCM_phys(:,:,:)=TI_GCM_start(:,:,:)
+   endif !soil_pem
 
       DO ig = 1,ngrid
-          tsurf(ig) = 0.
-          
-             DO islope = 1,nslope
-                 tsurf(ig) = tsurf(ig) + tsurf_slope(ig,islope) &
-                            * subslope_dist(ig,islope)      
-             ENDDO
+        tsurf(ig) = 0.
+        DO islope = 1,nslope
+          tsurf(ig) = tsurf(ig) + tsurf_slope(ig,islope) &
+                     * subslope_dist(ig,islope)      
+        ENDDO
       ENDDO ! of DO ig=1,ngrid
 
       DO ig = 1,ngrid
-         DO iloop = 1,nsoilmx
+        DO iloop = 1,nsoilmx
           tsoil(ig,iloop) = 0.
           inertiesoil(ig,iloop) = 0.
-             DO islope = 1,nslope
-                  tsoil(ig,iloop) =  tsoil(ig,iloop) + tsoil_slope(ig,iloop,islope) &
+          DO islope = 1,nslope
+            tsoil(ig,iloop) =  tsoil(ig,iloop) + tsoil_slope(ig,iloop,islope) &
                             * subslope_dist(ig,islope)   
-                  inertiesoil(ig,iloop) =  inertiesoil(ig,iloop) + TI_GCM_phys(ig,iloop,islope) &
+            inertiesoil(ig,iloop) =  inertiesoil(ig,iloop) + TI_GCM_phys(ig,iloop,islope) &
                             * subslope_dist(ig,islope)         
-             ENDDO
           ENDDO
+        ENDDO
       ENDDO ! of DO ig=1,ngrid
 
-! III_a.3 Surface optical properties
+! III_a.3 Surface optical properties (for startfi)
 
     DO ig = 1,ngrid
